// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// BoxedgeDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Boxedge.h"
#include "BoxedgeDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoxedgeDlg _CAO

CBoxedgeDlg::CBoxedgeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBoxedgeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoxedgeDlg)
	m_color = 2;
	m_threshold = 40;
	m_linewidth = 0;
	m_hpitch = 10;
	m_hlinenum = 9;
	m_vpitch = 10;
	m_vlinenum = 21;
	m_info = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
}

void CBoxedgeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoxedgeDlg)
	DDX_CBIndex(pDX, IDC_COLOR, m_color);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxInt(pDX, m_threshold, 0, 100);
	DDX_Text(pDX, IDC_LINEWIDTH, m_linewidth);
	DDX_Text(pDX, IDC_HPITCH, m_hpitch);
	DDX_Text(pDX, IDC_HLINENUM, m_hlinenum);
	DDX_Text(pDX, IDC_VPITCH, m_vpitch);
	DDX_Text(pDX, IDC_VLINENUM, m_vlinenum);
	DDX_Text(pDX, IDC_INFO, m_info);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBoxedgeDlg, CDialog)
	//{{AFX_MSG_MAP(CBoxedgeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_SETSCANWND, OnSetscanwnd)
	ON_BN_CLICKED(IDC_APPLYCHANGES, OnApplychanges)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoxedgeDlg bZ[W nh

BOOL CBoxedgeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxEdge.CreateInstance( __uuidof( FvxEdge ) ); 
		m_EdgeScanBox.CreateInstance( __uuidof( FvRectangle ) ); 

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay( 1 , 0 );
		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage );

		// J荞ݖ
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );

		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// GbWo͈͂̏lݒ
		m_EdgeScanBox->Putxs( 60 );
		m_EdgeScanBox->Putys( 160 );
		m_EdgeScanBox->Putxe( 480 );
		m_EdgeScanBox->Putye( 310 );

	    m_dblCenterX = ( m_EdgeScanBox->Getxs() + m_EdgeScanBox->Getxe() ) / 2;
		m_dblCenterY = ( m_EdgeScanBox->Getys() + m_EdgeScanBox->Getye() ) / 2;

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_COLOR );
		pcmb->AddString( "" );
		pcmb->AddString( "" );
		pcmb->AddString( "w" );
		m_color = 2;
		UpdateData(FALSE); 
		
		ApplyChanges();
		DrawScanLines();

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;
		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CBoxedgeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CBoxedgeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CBoxedgeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// eRg[ɓ͂ꂽp[^̓Kp
long CBoxedgeDlg::ApplyChanges()
{

    long lngTemp = 0;
    long lngErr = 0;
    CString strErrMesg;
    
	if( !UpdateData( TRUE )) return -1;

    // o{
    lngTemp = m_hlinenum;
    if ( lngTemp % 2  == 0 ) {
        lngTemp = lngTemp + 1;
        m_hlinenum = lngTemp;
	}

	if ( lngTemp < 0 ) {
        strErrMesg = "{0ȏ̊͂ĂB\r\n";
        lngErr = -1;
    } else {
        m_lngHLineNum = lngTemp;
	}
			
    // co{
    lngTemp = m_vlinenum;
    if ( lngTemp % 2 == 0 ) {
        lngTemp = lngTemp + 1;
        m_vlinenum = lngTemp;
	}
		
	if ( lngTemp < 0 ) {
        strErrMesg = strErrMesg + "c{0ȏ̊͂ĂB\r\n";
        lngErr = -1;
	} else {
		m_lngVLineNum = lngTemp;
	}
				
    // sb`
    lngTemp = m_hpitch;
    if ( lngTemp < 1 ) {
        strErrMesg = strErrMesg + "sb`1ȏ̐͂Ă\r\n";
        lngErr = -1;
	} else {
        m_lngHPitch = lngTemp;
	}
			
    // csb`
    lngTemp = m_vpitch;
    if ( lngTemp < 1 ) {
        strErrMesg = strErrMesg + "csb`1ȏ̐l͂Ă\r\n";
        lngErr = -1;
    } else {
        m_lngVPitch = lngTemp;
	}
			
	// 臒l
	lngTemp = m_threshold;
	if (( lngTemp < 0 ) || ( lngTemp > 100 ) ) {
		strErrMesg = strErrMesg + "臒l 0`100 ̊ԂŐݒ肵Ă\r\n";
		lngErr = -1;
	} else {
		m_FvxEdge->PutThresh ( lngTemp );
	}
			
	// Е
	lngTemp = m_linewidth;
	if( lngTemp < 0 ) {
		strErrMesg = strErrMesg + "Е͂OȏŐݒ肵Ă\r\n";
		lngErr = -1;
	} else {
		m_FvxEdge->PutLineWidth( lngTemp );
	}

	// Ώە̐F
    switch ( m_color ) {
		case 0:  //
			m_FvxEdge->PutEdgeColor( BLACK_TO_WHITE ) ;
			break;
		case 1:  //
			m_FvxEdge->PutEdgeColor( WHITE_TO_BLACK ) ;
			break;
        case 2:  //w
			m_FvxEdge->PutEdgeColor( ALL_COLOR ) ;
			break;
		default:
			m_FvxEdge->PutEdgeColor( ALL_COLOR ) ;
			break;
	}
	
	if ( lngErr != 0 )  MessageBox(strErrMesg , "G[" , MB_ICONWARNING | MB_OK );

    return lngErr;
}

// GbWo̕`
// ㉺Eꂼ̌oSFŕ\܂
void CBoxedgeDlg::DrawScanLines()
{

    // ͈
    m_FvxDisplayEx->PutPenColor( 0x808080 );
    m_FvxDisplayEx->DrawData( 0, m_EdgeScanBox );

    // 
	IFvLineSegmentPtr pEdgeScanLine( __uuidof(FvLineSegment) ); //GbWo
    pEdgeScanLine->Putxs( m_dblCenterX );
    
	long j = m_lngHLineNum / 2;
    for( long i = -j ; i <= j ; i++ ) {
        pEdgeScanLine->Putys( m_dblCenterY + m_lngHPitch * i );
        pEdgeScanLine->Putye( pEdgeScanLine->Getys() );
    
        // ͈͂Ɏ܂Ă邩H
        if (( m_EdgeScanBox->Getys() <=  pEdgeScanLine->Getys() ) && ( pEdgeScanLine->Getys() <= m_EdgeScanBox->Getye() )) {
            
            pEdgeScanLine->Putxe( m_EdgeScanBox->Getxe() );
            m_FvxDisplayEx->PutPenColor( 0x80FF80 );
            m_FvxDisplayEx->DrawData( 0, pEdgeScanLine );
            
            pEdgeScanLine->Putxe( m_EdgeScanBox->Getxs() ); 
            m_FvxDisplayEx->PutPenColor( 0x8080FF );
            m_FvxDisplayEx->DrawData( 0, pEdgeScanLine );
		}
	}

    // c
    pEdgeScanLine->Putys( m_dblCenterY );
    j = m_lngVLineNum / 2 ;
    for( i = -j ; i <= j ; i++ ) {
       pEdgeScanLine->Putxs( m_dblCenterX + m_lngVPitch * i ); 
        pEdgeScanLine->Putxe( pEdgeScanLine->Getxs() );
        
       // ͈͂Ɏ܂Ă邩H
       if (( m_EdgeScanBox->Getxs() <= pEdgeScanLine->Getxs() ) && ( pEdgeScanLine->Getxs() <= m_EdgeScanBox->Getxe() )) {
			pEdgeScanLine->Putye( m_EdgeScanBox->Getye() );
			m_FvxDisplayEx->PutPenColor( 0x80FFFF );
			m_FvxDisplayEx->DrawData( 0, pEdgeScanLine );
      
			pEdgeScanLine->Putye( m_EdgeScanBox->Getys() );
            m_FvxDisplayEx->PutPenColor( 0xFFFF80 );
            m_FvxDisplayEx->DrawData( 0, pEdgeScanLine );
		}
	}
}

BOOL CBoxedgeDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CBoxedgeDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
	m_FvxVideo->ChangeImageSize( m_FvxImage );

	// 捞
	m_FvxVideo->GrabSync( m_FvxImage );	
    
	// 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage );

}

// 摜t@CǍ
void CBoxedgeDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

        // FileAccessR|[lgpāA
        // t@CImageɉ摜ǂݍ݂܂
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if ( ( m_FvxImage->GetBitPerPixel() != 8 ) || ( m_FvxImage->GetImageType()!=imageGray ) ){

			MessageBox("OC摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage->PutBitPerPixel( 8 );
            m_FvxImage->PutImageType( imageGray );
            m_FvxImage->PutImageWidth( 512 );
            m_FvxImage->PutImageHeight( 480 );
		}
	    m_FvxDisplayEx->DrawImage( m_FvxImage );
	}
}

// 摜t@Cۑ
void CBoxedgeDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t(cFileDlg.GetPathName()) );

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage ); 			
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}	
}

BEGIN_EVENTSINK_MAP(CBoxedgeDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CBoxedgeDlg)
	ON_EVENT(CBoxedgeDlg, IDC_FVXDISPLAYEX1, 3 /* MouseMove */, OnMouseMoveFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CBoxedgeDlg, IDC_FVXDISPLAYEX1, 1 /* MouseDown */, OnMouseDownFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// }EXړꂽƂ̏
void CBoxedgeDlg::OnMouseMoveFvxdisplayex1(long Button, long Shift, long X, long Y, long InOut) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    if ( Button == 1 ) {
        // oQ̒Sړ
		MoveCenter( X, Y );
	}
}

// }EX̃{^ꂽƂ̏
void CBoxedgeDlg::OnMouseDownFvxdisplayex1(long Button, long Shift, long X, long Y, long InOut) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    if ( Button == 1 ) {
        // oQ̒Sړ
		MoveCenter( X, Y );
	}
}

// oQ̒Sړ
void CBoxedgeDlg::MoveCenter(long X, long Y)
{

	double  dblX = X;
	double  dblY = Y;

    // NbsO
    if ( dblX < m_EdgeScanBox->Getxs() ) dblX = m_EdgeScanBox->Getxs() ;
    if ( dblY < m_EdgeScanBox->Getys() ) dblY = m_EdgeScanBox->Getys() ;
    if ( m_EdgeScanBox->Getxe() < dblX ) dblX = m_EdgeScanBox->Getxe() ;
    if ( m_EdgeScanBox->Getye() < dblY ) dblY = m_EdgeScanBox->Getye() ;
    
    m_dblCenterX = dblX;
    m_dblCenterY = dblY;
    
    // oĕ`
    m_FvxDisplayEx->ClearOverlay( -1 );
    DrawScanLines();

}

// ͈͂̐ݒ
void CBoxedgeDlg::OnSetscanwnd() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // ݂̒llƂēKp܂B
    m_FvxROI->SetRectangle( m_EdgeScanBox );
    // FvxROIgĔ͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->PutUseRectangle( TRUE );
    
    long lngOk = 0;
	m_FvxROI->MakeROIDialog( m_FvxImage, &lngOk );
    
    if (( lngOk == 1 ) &&  ( m_FvxROI->GetCheckRectangle() == 1 )) {
        m_FvxROI->GetRectangle( m_EdgeScanBox );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
	    double dblTemp ;
        if ( m_EdgeScanBox->Getxe() < m_EdgeScanBox->Getxs() ) {
            dblTemp = m_EdgeScanBox->Getxs();
            m_EdgeScanBox->Putxs( m_EdgeScanBox->Getxe() );
            m_EdgeScanBox->Putxe( dblTemp );
		}
		if ( m_EdgeScanBox->Getye() < m_EdgeScanBox->Getys()  ) {
            dblTemp = m_EdgeScanBox->Getys();
            m_EdgeScanBox->Putys( m_EdgeScanBox->Getye() );
            m_EdgeScanBox->Putye( dblTemp );
		}
	}
		
    // öʒuړ܂
    m_dblCenterX = (m_EdgeScanBox->Getxs() + m_EdgeScanBox->Getxe()) / 2;
    m_dblCenterY = (m_EdgeScanBox->Getys() + m_EdgeScanBox->Getye()) / 2;
    
    m_FvxDisplayEx->ClearOverlay( -1 );
    DrawScanLines();
	
}

// p[^Kp
void CBoxedgeDlg::OnApplychanges() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxDisplayEx->ClearOverlay( -1 );
    if ( ApplyChanges() == 0 ) {
        DrawScanLines();
	}
}

// GbWos
// SA㉺Eꂼ̕ɑ΂ČoA
// OɌđAGbW_߂܂
void CBoxedgeDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

    // ʏ
    m_FvxDisplayEx->ClearOverlay( -1 );
    
	try {
    
		// p[^Kp
		if ( ApplyChanges() == 0 ) {

			// 
			IFvLineSegmentPtr pEdgeScanLine( __uuidof( FvLineSegment ) ); //GbWo
			IFvEdgeResultPtr pEdgeResult( __uuidof ( FvEdgeResult ) );    //GbWo

			// GbW_͐ŕ\
			m_FvxDisplayEx->PutPenColor( 0xFF0000 );
    
			// ԌvJn
			m_FvxPerformanceCounter->StartCount();
    
			pEdgeScanLine->Putxs( m_dblCenterX );
			long lngLoop = m_lngHLineNum / 2 ;
			
			for (long i = -lngLoop ; i <= lngLoop ; i++ ) {

				pEdgeScanLine->Putxe( m_EdgeScanBox->Getxe() );
				pEdgeScanLine->Putys( m_dblCenterY + m_lngHPitch * i );
				pEdgeScanLine->Putye( pEdgeScanLine->Getys() );
        
				// ͈͂Ɏ܂Ă邩H
				if ( ( m_EdgeScanBox->Getys() <= pEdgeScanLine->Getys() ) && ( pEdgeScanLine->Getys() <= m_EdgeScanBox->Getye()) ) {
            
					// GbWos
					long lngCount;
					m_FvxEdge->Execute( m_FvxImage, pEdgeScanLine, &lngCount );
    
					if ( lngCount >= 1 ) {
						m_FvxEdge->GetResult( 0, pEdgeResult ) ;  // oGbW͂P_݂̂Ȃ̂ŁAIndexNo0
						m_FvxDisplayEx->DrawData( 0, pEdgeResult );
					}
						
					// Ώ̂ȔΑ
					pEdgeScanLine->Putxe( m_EdgeScanBox->Getxs() );
            
					// GbWos
					m_FvxEdge->Execute( m_FvxImage, pEdgeScanLine, &lngCount );
    
					if ( lngCount >= 1 ) {
						m_FvxEdge->GetResult( 0, pEdgeResult );
						m_FvxDisplayEx->DrawData( 0, pEdgeResult );
					}
				}
			}
				
			// 
			pEdgeScanLine->Putys( m_dblCenterY );
			lngLoop = m_lngVLineNum / 2 ;
			
			for ( i = -lngLoop ; i <= lngLoop ; i++ ) {
        
				pEdgeScanLine->Putxs( m_dblCenterX + m_lngVPitch * i );
				pEdgeScanLine->Putxe( pEdgeScanLine->Getxs() );
				pEdgeScanLine->Putye( m_EdgeScanBox->Getye() );
        
				// ͈͂Ɏ܂Ă邩H
				if ( ( m_EdgeScanBox->Getxs() <= pEdgeScanLine->Getxs() ) && ( pEdgeScanLine->Getxs() <= m_EdgeScanBox->Getxe() )) {
            
					// GbWos
					long lngCount;
					m_FvxEdge->Execute( m_FvxImage, pEdgeScanLine, &lngCount );
    
					if ( lngCount >= 1 ) {
						m_FvxEdge->GetResult(  0, pEdgeResult );
						m_FvxDisplayEx->DrawData( 0, pEdgeResult );
					}
						
					// Ώ̂ȔΑ
					pEdgeScanLine->Putye( m_EdgeScanBox->Getys() );
            
					// GbWos
					m_FvxEdge->Execute( m_FvxImage, pEdgeScanLine, &lngCount );
    
					if ( lngCount >= 1 ) {
						m_FvxEdge->GetResult( 0, pEdgeResult );
						m_FvxDisplayEx->DrawData( 0, pEdgeResult );
					}
				}
			}
				
			// ԌvI
			double dblTime = 0; 
			m_FvxPerformanceCounter->StopCount( &dblTime );
    		m_info.Format("%fms", dblTime );
			UpdateData( FALSE );
		}

	} catch (_com_error) {

		long lngErr = 0;
		CString cStr;

		m_FvxEdge->GetErrReport( &lngErr );

		switch ( lngErr ) {
			case 0:
				cStr.Format("G[");
				break;
			case 4005:
				cStr.Format("p[^Ⴂ܂ err_no = %d", lngErr );
				break;
			case 4006:
				cStr.Format("̌^Ⴂ܂ err_no = %d", lngErr );
				break;
			case 4007:
				cStr.Format("NULLw肳Ă܂ err_no = %d", lngErr );
				break;
			case 4013:
				cStr.Format("̈悪w肳Ă܂  err_no = %d", lngErr );
				break;
			default:
				cStr.Format("sȃG[ err_no = %d", lngErr );
				break;
		}

		MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
		return;
	}
}

void CBoxedgeDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

void CBoxedgeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
}
